package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;

import com.ekexiu.portal.po.Operation;

@DAO
public abstract class OperationDao {
	@Insert
	public abstract int insert(Connection con, Operation operation) throws SQLException;
	
	@Update
	public abstract int update(Connection con, Operation operation) throws SQLException;
	
	@UpdateWith
	@From(Operation.class)
	public abstract int updateDetailDemand(Connection con, String operationId, String detailDemand) throws SQLException;
	
	@UpdateWith
	@From(Operation.class)
	public abstract int updateOperationStatus(Connection con, String operationId, int operationStatus) throws SQLException;
	
	@UpdateWith
	@From(Operation.class)
	public abstract int updateDeliverTime(Connection con, String operationId, String deliverTime) throws SQLException;
	
	@UpdateWith
	@From(Operation.class)
	public abstract int updatePayMethod(Connection con, String operationId, String payMethod) throws SQLException;
	
	@Nullable
	@SelectOne
	public abstract Operation query(Connection con, String operationId) throws SQLException;
	
	@SelectList
	public abstract List<Operation> query(Connection con) throws SQLException;
	
	@SelectList
	public abstract List<Operation> queryPro(Connection con, String demandId) throws SQLException;
	
	@SelectList
	public abstract List<Operation> queryRes(Connection con, String resourceId) throws SQLException;
	
	@DeleteWith
	@From(Operation.class)
	public abstract int delete(Connection con, String operationId) throws SQLException;
	
	@DeleteWith
	@From(Operation.class)
	public abstract int deleteProRes(Connection con, String demandId, String resourceId) throws SQLException;
	
}
